<id>
Buddy List
</id>

<version>
1.2
</version>

<mod info>
This is a basic buddy list. It allows you to easily add people to your list through their profile. Once on your list it shows your buddies in the "who is online" area and makes it easy to select people to send IM's too.
</mod info>

<author>
Matthew (Grudge) Wolf
</author>

<homepage>
www.mymods.co.uk
</homepage>

<edit file>
$sourcedir/BoardIndex.php
</edit file>

<search for>
	$context['num_guests'] = 0;
</search for>

<add before>
	$context['num_buddies'] = 0;
	// Little cheat.
	$user_info['buddy_list'] = explode(',', $user_info['buddy_list']);

</add before>

<search for>
		elseif (!empty($row['showOnline']) || allowedTo('moderate_forum'))
		{
</search for>

<add after>
			if (in_array($row['ID_MEMBER'], $user_info['buddy_list']))
			{
				$context['num_buddies']++;
				// Change the online color - this is HARD CODED!!
				$row['onlineColor'] = 'blue';
			}
</add after>

<edit file>
$sourcedir/InstantMessage.php
</edit file>

<search for>
		'send' => 'MessagePost',
</search for>

<add before>
		'buddy' => 'BuddyManage',
</add before>

<search for>
// Send a new message?
function MessagePost()
{
</search for>

<add after>
	global $user_info;
</add after>

<search for>
	// Quoting/Replying to a message?
</search for>

<add before>
	// Buddy list.
	$result = db_query("
		SELECT memberName
		FROM {$db_prefix}members
		WHERE FIND_IN_SET(ID_MEMBER, '" . $user_info['buddy_list']. "')
		LIMIT " . (substr_count($user_info['buddy_list'], ',') + 1), __FILE__, __LINE__);
	$context['buddy_list'] = array();
	while ($row = mysql_fetch_assoc($result))
		$context['buddy_list'][] = $row['memberName'];
	mysql_free_result($result);

</add before>

<search for>
}

?>
</search for>

<add before>
}

function BuddyManage()
{
	global $db_prefix, $ID_MEMBER, $user_info;

	if (!isset($_GET['u']) || $user_info['is_guest'])
		fatal_error("Hacker!");

	$memID = $_GET['u'];

	// Explode the current buddy list.
	$buddies = explode(',', $user_info['buddy_list']);
	$key = array_search($memID, $buddies);

	if ($key === FALSE || $key == NULL)
		$buddies[] = $memID;
	else
		unset($buddies[$key]);
	$user_info['buddy_list'] = implode(',', $buddies);

	// Now the buddy list is accurate save it!
	db_query("
		UPDATE {$db_prefix}members
		SET buddyList = '$user_info[buddy_list]'
		WHERE ID_MEMBER = $ID_MEMBER", __FILE__, __LINE__);

	redirectexit('action=profile;u=' . $memID);
</add before>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
		'messages' => empty($user_settings['instantMessages']) ? 0 : $user_settings['instantMessages'],
</search for>

<add before>
		'buddy_list' => $user_settings['buddyList'],
</add before>

<search for>
			mem.totalTimeLoggedIn, mem.ID_POST_GROUP, mem.notifyAnnouncements, mem.notifyOnce,
</search for>

<add after>
			mem.buddyList,
</add after>

<edit file>
$sourcedir/Profile.php
</edit file>

<search for>
		'smileySet',
</search for>

<add before>
		'buddyList',
</add before>

<search for>
	// Validate the smiley set.
</search for>

<add before>
	// Validate and set the buddylist...
	if (isset($_POST['buddyList']))
	{
		$_POST['buddyList'] = strtr(trim($_POST['buddyList']), array("\n" => ',', "\r" => '', '_' => '\\_', '%' => '\\%'));

		$result = db_query("
			SELECT ID_MEMBER
			FROM {$db_prefix}members
			WHERE FIND_IN_SET(memberName, '$_POST[buddyList]')
			LIMIT " . (substr_count($_POST['buddyList'], ',') + 1), __FILE__, __LINE__);
		$_POST['buddyList'] = '';
		while ($row = mysql_fetch_assoc($result))
			$_POST['buddyList'] .= $row['ID_MEMBER'] . ',';
		mysql_free_result($result);
		$_POST['buddyList'] = substr($_POST['buddyList'], 0, -1);
	}

</add before>

<search for>
		$context['member']['hostname'] = preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/', $themeUser[$memID]['ip']) == 1 && empty($modSettings['disableHostnameLookup']) ? @gethostbyaddr($themeUser[$memID]['ip']) : '';
</search for>

<add after>
	$context['member']['is_buddy'] = in_array($memID, explode(',', $user_info['buddy_list']));
</add after>

<search for>
	$context['ignore_list'] = $im_ignore_list;
</search for>

<add after>
	// Do the same for buddy list.
	$result = db_query("
		SELECT memberName
		FROM {$db_prefix}members
		WHERE FIND_IN_SET(ID_MEMBER, '" . $user_profile[$memID]['buddyList']. "')
		LIMIT " . (substr_count($user_profile[$memID]['buddyList'], ',') + 1), __FILE__, __LINE__);
	$context['buddy_list'] = '';
	while ($row = mysql_fetch_assoc($result))
		$context['buddy_list'] .= "\n" . $row['memberName'];
	mysql_free_result($result);
	$context['buddy_list'] = substr($context['buddy_list'], 1);

</add after>

<edit file>
$themedir/BoardIndex.template.php
</edit file>

<search for>
			<a href="', $scripturl, '?action=who">', $context['num_guests'], ' ', $context['num_guests'] == 1 ? $txt['guest'] : $txt['guests'], ', ', $context['num_users_online'], ' ', $context['num_users_online'] == 1 ? $txt['user'] : $txt['users'], (empty($context['num_users_hidden']) ? '' : ' (' . $context['num_users_hidden'] . ' ' . $txt['hidden'] . ')'), '</a><br />
</search for>

<replace>
			<a href="', $scripturl, '?action=who">', $context['num_guests'], ' ', $context['num_guests'] == 1 ? $txt['guest'] : $txt['guests'], ', ', $context['num_buddies'], ' ', $context['num_buddies'] == 1 ? $txt['buddylist_buddy'] : $txt['buddylist_buddies'], ', ', $context['num_users_online'], ' ', $context['num_users_online'] == 1 ? $txt['user'] : $txt['users'], (empty($context['num_users_hidden']) ? '' : ' (' . $context['num_users_hidden'] . ' ' . $txt['hidden'] . ')'), '</a><br />
</replace>

<edit file>
$themedir/InstantMessage.template.php
</edit file>

<search for>
									<input type="text" name="to" id="to" value="', $context['to'], '" size="40" />&nbsp;
</search for>

<add after>
	';
	// Do the buddy list.
	if (!empty($context['buddy_list']))
	{
		echo '
			<script language="JavaScript1.2" type="text/javascript"><!--
				function fillBox(box, text)
				{
					if (document.getElementById(box).value != "")
					{
						if (document.getElementById(text).value != "")
							document.getElementById(text).value += ", ";
						document.getElementById(text).value += document.getElementById(box).value;
						document.getElementById(box).selectedIndex = 0;
					}
				}
			// --></script>
			<select name="buddy" id="buddy" onchange="fillBox(\'buddy\', \'to\');">
				<option value="" disabled="disabled">', $txt['buddylist_select'], '</option>';
		foreach ($context['buddy_list'] as $name)
			echo '
				<option value="', $name, '">', $name, '</option>';
		echo '
			</select>';
	}
	echo '
</add after>

<search for>
									<input type="text" name="bcc" id="bcc" value="', $context['bcc'], '" size="40" />&nbsp;
</search for>

<add after>
	';
	// Do the buddy list.
	if (!empty($context['buddy_list']))
	{
		echo '
			<select name="buddy2" id="buddy2" onchange="fillBox(\'buddy2\', \'bcc\');">
				<option value="" disabled="disabled">', $txt['buddylist_select'], '</option>';
		foreach ($context['buddy_list'] as $name)
			echo '
				<option value="', $name, '">', $name, '</option>';
		echo '
			</select>';
	}
	echo '
</add after>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
$txt['buddylist_buddies'] = 'Buddies';
$txt['buddylist_buddy'] = 'Buddy';
$txt['buddylist_select'] = 'Select Buddy';
$txt['buddyList_title'] = 'Buddy List';
$txt['buddyList_add_name'] = 'Add one Username on each line.';
$txt['buddyList_add'] = 'Add this member to my Buddy List';
$txt['buddyList_remove'] = 'Remove this member from my Buddy List';
</add before>

<edit file>
$themedir/Profile.template.php
</edit file>

<search for>
			<a href="', $scripturl, '?action=pm;sa=send;u=', $context['member']['id'], '">', $txt[688], '.</a><br />
			<br />';
</search for>

<add after>
	if (!$context['user']['is_owner'] && !$context['user']['is_guest'])
		echo '
			<a href="', $scripturl, '?action=pm;sa=buddy;u=', $context['member']['id'], '">', $context['member']['is_buddy'] ? $txt['buddyList_remove'] : $txt['buddyList_add'], '.</a><br />
			<br />';
</add after>

<search for>
									<textarea name="im_ignore_list" id="im_ignore_list" rows="10" cols="50">', $context['ignore_list'], '</textarea>
</search for>

<add after>
								</td>
							</tr>';

	// A text box for the user to input usernames of everyone they want to put on their buddy list.
	echo '
							<tr>
								<td valign="top" align="left">
									<b>', $txt['buddyList_title'], ':</b><br />
									<span class="smalltext">
										', $txt['buddyList_add_name'], '<br />
										<br />
										<a href="', $scripturl, '?action=findmember;input=buddyList;delim=\\\\n;sesc=', $context['session_id'], '" onclick="return reqWin(this.href, 350, 400);"><img src="', $settings['images_url'], '/assist.gif" border="0" alt="', $txt['find_members'], '" align="middle" /> ', $txt['find_members'], '</a>
									</span>
								</td>
								<td>
									<textarea name="buddyList" id="buddyList" rows="10" cols="50">', $context['buddy_list'], '</textarea>
</add after>